

<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.25.17. grn_inspect &#8212; Groonga v10.1.1-31-g1e46ba6 documentation</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="7.25.18. grn_match_escalation" href="grn_match_escalation.html" />
    <link rel="prev" title="7.25.16. grn_info" href="grn_info.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">An open-source fulltext search engine and column store.</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../ja/html/reference/api/grn_inspect.html">日本語</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="grn_match_escalation.html" title="7.25.18. grn_match_escalation"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="grn_info.html" title="7.25.16. grn_info"
             accesskey="P">previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" accesskey="U"><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.17. </span><code class="docutils literal notranslate"><span class="pre">grn_inspect</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="grn-inspect">
<h1><span class="section-number">7.25.17. </span><code class="docutils literal notranslate"><span class="pre">grn_inspect</span></code><a class="headerlink" href="#grn-inspect" title="Permalink to this headline">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.25.17.1. </span>Summary<a class="headerlink" href="#summary" title="Permalink to this headline">¶</a></h2>
<p>There are two kind of functions to inspect <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj"><code class="xref c c-type docutils literal notranslate"><span class="pre">grn_obj</span></code></a>. One is <code class="docutils literal notranslate"><span class="pre">grn_inspect</span></code> function, The other is <code class="docutils literal notranslate"><span class="pre">grn_p</span></code> function.</p>
<p>Here is the list of <code class="docutils literal notranslate"><span class="pre">grn_inspect</span></code> function series. It sets inspected text into specified object.</p>
<ul class="simple">
<li><p><a class="reference internal" href="#c.grn_inspect" title="grn_inspect"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_inspect_indented" title="grn_inspect_indented"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_indented()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_inspect_limited" title="grn_inspect_limited"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_limited()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_inspect_name" title="grn_inspect_name"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_name()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_inspect_encoding" title="grn_inspect_encoding"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_encoding()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_inspect_type" title="grn_inspect_type"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_type()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_inspect_query_log_flags" title="grn_inspect_query_log_flags"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_query_log_flags()</span></code></a></p></li>
</ul>
<p>Here is the list of <code class="docutils literal notranslate"><span class="pre">grn_p</span></code> function series. It prints inspected text into console.</p>
<ul class="simple">
<li><p><a class="reference internal" href="#c.grn_p" title="grn_p"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_p()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_p_geo_point" title="grn_p_geo_point"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_p_geo_point()</span></code></a></p></li>
<li><p><a class="reference internal" href="#c.grn_p_ii_values" title="grn_p_ii_values"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_p_ii_values()</span></code></a></p></li>
</ul>
</div>
<div class="section" id="example">
<h2><span class="section-number">7.25.17.2. </span>Example<a class="headerlink" href="#example" title="Permalink to this headline">¶</a></h2>
<p>Here is an example which inspects specified target object.</p>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="p">);</span>
<span class="cm">/* equivalent to grn_p(ctx, obj); */</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;inspected: &lt;%.*s&gt;</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
</div>
<div class="section" id="reference">
<h2><span class="section-number">7.25.17.3. </span>Reference<a class="headerlink" href="#reference" title="Permalink to this headline">¶</a></h2>
<dl class="c function">
<dt id="c.grn_inspect">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>A table is specified and it’s table type is <code class="docutils literal notranslate"><span class="pre">TABLE_PAT_KEY</span></code>, all keys are shown.
If you do not want to this behavior, use <a class="reference internal" href="#c.grn_inspect_limited" title="grn_inspect_limited"><code class="xref c c-func docutils literal notranslate"><span class="pre">grn_inspect_limited()</span></code></a> instead.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is inspected text will be stored.</p></li>
<li><p><strong>obj</strong> – The inspect target object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is inspected text is set.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;%.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>If obj is <code class="docutils literal notranslate"><span class="pre">TABLE_PAT_KEY</span></code> table, it prints like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>#&lt;table:pat Users key:ShortText value:(nil) size:7 columns:[] default_tokenizer:(nil) normalizer:(nil) keys:[&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;, &quot;e&quot;, &quot;f&quot;, &quot;g&quot;] subrec:none nodes:{
4{0,5,0}
  L:2{0,6,0}
    L:1{0,7,0}
      L:0{0,0,0}
      R:1{0,7,0}(&quot;a&quot;)[01100001]
...
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_inspect_indented">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect_indented</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em>, <em class="property">const</em> char *<em>indent</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect_indented" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p><code class="docutils literal notranslate"><span class="pre">indent</span></code> is only added if inspected text contains newline (inspected text must be multiple lines).</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is inspected text will be stored.</p></li>
<li><p><strong>obj</strong> – The inspect target object.</p></li>
<li><p><strong>indent</strong> – The pre-pended indentation text.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is inspected text is set with indent.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect_indented</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="p">,</span> <span class="s">&quot;***&quot;</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;%.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>If obj is <code class="docutils literal notranslate"><span class="pre">TABLE_PAT_KEY</span></code> table, it prints like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>***#&lt;table:pat Users key:ShortText value:(nil) size:7 columns:[] default_tokenizer:(nil) normalizer:(nil) keys:[&quot;a&quot;, &quot;b&quot;, &quot;c&quot;, &quot;d&quot;, &quot;e&quot;, &quot;f&quot;, &quot;g&quot;] subrec:none nodes:{
***4{0,5,0}
***  L:2{0,6,0}
***    L:1{0,7,0}
***      L:0{0,0,0}
***      R:1{0,7,0}(&quot;a&quot;)[01100001]
...
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_inspect_limited">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect_limited</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect_limited" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 7.0.0.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>If inspected text is too long, it will be truncated.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is inspected(truncated) text will be stored.</p></li>
<li><p><strong>obj</strong> – The inspect target object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is object detail is set.
If inspected text is longer than 64 characters, inspected text is truncated to it. Otherwise, inspected text will not be truncated.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;#=&gt; %.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>Even though if obj is <code class="docutils literal notranslate"><span class="pre">TABLE_PAT_KEY</span></code> table, it prints truncated result like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>#&lt;table:pat Users key:ShortText value:(nil) size:7 columns:[] de...(502)
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_inspect_name">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect_name</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect_name" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is object name will be stored.</p></li>
<li><p><strong>obj</strong> – The inspect target object.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is name of object is set.
If target object is nil, <code class="docutils literal notranslate"><span class="pre">(nil)</span></code> is set to buffer, if target object is internally used object, <code class="docutils literal notranslate"><span class="pre">(anonymouse:</span> <span class="pre">ID)</span></code> is set to buffer.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect_name</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;%.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>Specified object name is printed like this:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>Users
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_inspect_encoding">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect_encoding</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, <a class="reference internal" href="grn_encoding.html#c.grn_encoding" title="grn_encoding">grn_encoding</a> <em>encoding</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect_encoding" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is encoding name will be stored.</p></li>
<li><p><strong>encoding</strong> – The inspect target encoding. encoding must be <code class="docutils literal notranslate"><span class="pre">GRN_ENC_DEFAULT</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_ENC_NONE</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_ENC_EUC_JP</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_ENC_UTF8</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_ENC_SJIS</span></code>, <code class="docutils literal notranslate"><span class="pre">GRN_ENC_LATIN1</span></code> or <code class="docutils literal notranslate"><span class="pre">GRN_ENC_KOI8R</span></code></p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is encoding name is set.
If invalid <code class="docutils literal notranslate"><span class="pre">encoding</span></code> is given, <code class="docutils literal notranslate"><span class="pre">(unknown:</span> <span class="pre">ENCODING)</span></code> is set to <code class="docutils literal notranslate"><span class="pre">buffer</span></code>.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect_encoding</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">GRN_ENC_UTF8</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;%.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>Specified encoding name is printed like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>UTF-8
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_inspect_type">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect_type</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, unsigned char <em>type</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect_type" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is type name will be stored.</p></li>
<li><p><strong>type</strong> – The inspect target type.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is type name is set.
If invalid <code class="docutils literal notranslate"><span class="pre">type</span></code> is given, <code class="docutils literal notranslate"><span class="pre">(unknown:</span> <span class="pre">TYPE_IN_HEX)</span></code> is set to <code class="docutils literal notranslate"><span class="pre">buffer</span></code>.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">grn_inspect_type</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="o">-&gt;</span><span class="n">header</span><span class="p">.</span><span class="n">type</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;#=&gt; %.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>If obj is builtin type, type name is printed like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>GRN_TYPE
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_inspect_query_log_flags">
<a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<code class="sig-name descname">grn_inspect_query_log_flags</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>buffer</em>, unsigned int <em>flags</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_inspect_query_log_flags" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 7.0.4.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">flag</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>buffer</strong> – The buffer object which is flag name will be stored.</p></li>
<li><p><strong>flags</strong> – The inspect target type.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p><code class="docutils literal notranslate"><span class="pre">buffer</span></code> object which is flag name is set.
If invalid <code class="docutils literal notranslate"><span class="pre">flags</span></code> is given, empty string is set to <code class="docutils literal notranslate"><span class="pre">buffer</span></code>.</p>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">buffer</span><span class="p">;</span>
<span class="n">GRN_TEXT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="kt">int</span> <span class="n">current_flags</span> <span class="o">=</span> <span class="n">grn_query_logger_get_flags</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">);</span>
<span class="n">grn_inspect_query_log_flags</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">current_flags</span><span class="p">);</span>
<span class="n">printf</span><span class="p">(</span><span class="s">&quot;%.*s</span><span class="se">\n</span><span class="s">&quot;</span><span class="p">,</span> <span class="p">(</span><span class="kt">int</span><span class="p">)</span><span class="n">GRN_TEXT_LEN</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">),</span> <span class="n">GRN_TEXT_VALUE</span><span class="p">(</span><span class="o">&amp;</span><span class="n">buffer</span><span class="p">));</span>
</pre></div>
</div>
<p>The query logger flags are printed like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>COMMAND|RESULT_CODE|DESTINATION|CACHE|SIZE|SCORE
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_p">
void <code class="sig-name descname">grn_p</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_p" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.
It prints inspected text.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>obj</strong> – The inspect target object.</p></li>
</ul>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_p</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">buffer</span><span class="p">,</span> <span class="n">obj</span><span class="p">);</span>
</pre></div>
</div>
<p>If obj is <code class="docutils literal notranslate"><span class="pre">ShortText</span></code>, it prints like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>#&lt;type ShortText size:4096 type:var_size&gt;
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_p_geo_point">
void <code class="sig-name descname">grn_p_geo_point</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_geo.html#c.grn_geo_point" title="grn_geo_point">grn_geo_point</a> *<em>point</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_p_geo_point" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.
It prints inspected geo point text.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>point</strong> – The inspect target object.</p></li>
</ul>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_obj</span> <span class="n">point</span><span class="p">;</span>
<span class="kt">int</span> <span class="n">latitude</span> <span class="o">=</span> <span class="p">((</span><span class="mi">40</span> <span class="o">*</span> <span class="mi">60</span> <span class="o">*</span> <span class="mi">60</span><span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="mi">42</span> <span class="o">*</span> <span class="mi">60</span><span class="p">)</span> <span class="o">+</span> <span class="mi">46</span><span class="p">)</span> <span class="o">*</span> <span class="mi">1000</span><span class="p">;</span>
<span class="kt">int</span> <span class="n">longitude</span> <span class="o">=</span> <span class="p">((</span><span class="o">-</span><span class="mi">74</span> <span class="o">*</span> <span class="mi">60</span> <span class="o">*</span> <span class="mi">60</span><span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="mi">0</span> <span class="o">*</span> <span class="mi">60</span><span class="p">)</span> <span class="o">+</span> <span class="mi">22</span><span class="p">)</span> <span class="o">*</span> <span class="mi">1000</span><span class="p">;</span>
<span class="n">GRN_WGS84_GEO_POINT_INIT</span><span class="p">(</span><span class="o">&amp;</span><span class="n">point</span><span class="p">,</span> <span class="mi">0</span><span class="p">);</span>
<span class="n">GRN_GEO_POINT_SET</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="o">&amp;</span><span class="n">point</span><span class="p">,</span> <span class="n">latitude</span><span class="p">,</span> <span class="n">longitude</span><span class="p">);</span>
<span class="n">grn_p_geo_point</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="p">(</span><span class="n">grn_geo_point</span><span class="o">*</span><span class="p">)</span><span class="o">&amp;</span><span class="n">point</span><span class="p">);</span>
</pre></div>
</div>
<p>If <code class="docutils literal notranslate"><span class="pre">point</span></code> indicates New York City, it prints like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[(524290,18) ((0, 8, 44, 290),(0, 0, 0, 18)) [00000000 00000000 00000000 10000000 00000000 00000000 00000001 00001100]]
</pre></div>
</div>
</dd></dl>

<dl class="c function">
<dt id="c.grn_p_ii_values">
void <code class="sig-name descname">grn_p_ii_values</code><span class="sig-paren">(</span><a class="reference internal" href="grn_ctx.html#c.grn_ctx" title="grn_ctx">grn_ctx</a> *<em>ctx</em>, <a class="reference internal" href="grn_obj.html#c.grn_obj" title="grn_obj">grn_obj</a> *<em>obj</em><span class="sig-paren">)</span><a class="headerlink" href="#c.grn_p_ii_values" title="Permalink to this definition">¶</a><br /></dt>
<dd><div class="versionadded">
<p><span class="versionmodified added">New in version 4.0.8.</span></p>
</div>
<p>Inspect specified target <code class="docutils literal notranslate"><span class="pre">obj</span></code> object.
It prints inspected index values.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>ctx</strong> – The context object</p></li>
<li><p><strong>obj</strong> – The inspect target object.</p></li>
</ul>
</dd>
</dl>
<div class="highlight-c notranslate"><div class="highlight"><pre><span></span><span class="n">grn_p_ii_values</span><span class="p">(</span><span class="o">&amp;</span><span class="n">context</span><span class="p">,</span> <span class="n">obj</span><span class="p">);</span>
</pre></div>
</div>
<p>If <code class="docutils literal notranslate"><span class="pre">obj</span></code> is an index column, it prints like the following:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>[
  #&lt;&quot;!&quot;
    elements:[
      {status:available, rid:1, sid:1, pos:0, tf:1, weight:0, rest:1},
      {status:available, rid:2, sid:1, pos:0, tf:1, weight:0, rest:1}
    ]
  &gt;,
  ...
</pre></div>
</div>
</dd></dl>

</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">Table of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.25.17. <code class="docutils literal notranslate"><span class="pre">grn_inspect</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.25.17.1. Summary</a></li>
<li><a class="reference internal" href="#example">7.25.17.2. Example</a></li>
<li><a class="reference internal" href="#reference">7.25.17.3. Reference</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="grn_info.html"
                        title="previous chapter"><span class="section-number">7.25.16. </span><code class="docutils literal notranslate"><span class="pre">grn_info</span></code></a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="grn_match_escalation.html"
                        title="next chapter"><span class="section-number">7.25.18. </span><code class="docutils literal notranslate"><span class="pre">grn_match_escalation</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="grn_match_escalation.html" title="7.25.18. grn_match_escalation"
             >next</a> |</li>
        <li class="right" >
          <a href="grn_info.html" title="7.25.16. grn_info"
             >previous</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>Reference manual</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../api.html" ><span class="section-number">7.25. </span>API</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.25.17. </span><code class="docutils literal notranslate"><span class="pre">grn_inspect</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>